// Идентификатор пользователя хранилища (GUID)
Перем Идентификатор Экспорт;
// Имя пользователя хранилища
Перем Имя Экспорт;
// Хеш пароля пользователя хранилища
Перем ХешПароля Экспорт;
// Пароль пользователя хранилища. Используется для изменения пароля
Перем Пароль Экспорт;
// Роль пользователя хранилища. Принимает значения перечисления РолиХранилища
Перем Роль Экспорт;
// Признак активности пользователя (если он авторизован)
Перем Активен Экспорт;
// Признак `удаления` пользователя. При Истина - пользователь деактивирован
Перем Удален Экспорт;

Процедура ПриСозданииНаСервере()
	Пароль = Неопределено;
КонецПроцедуры

// Заполняет объект на основе входящих данных
//
// Параметры:
//   ВходящиеДанные - Соответствие - результат разбора XML с помощью библиотеки xmp-parser
//
Процедура Заполнить(ВходящиеДанные) Экспорт
	
	info = ВходящиеДанные["info"];
	
	Идентификатор = Вспомогательный.ЗначениеСвойства(info, "id");
	Имя           = Вспомогательный.ЗначениеСвойства(info, "name");
	ХешПароля     = Вспомогательный.ЗначениеСвойства(info, "password");
	Роль          = РолиХранилища.РольИзСтроки(Вспомогательный.ЗначениеСвойства(info, "rights"));
	Активен       = Вспомогательный.ВычислитьБулево(Вспомогательный.ЗначениеСвойства(ВходящиеДанные, "online"));
	Удален        = Вспомогательный.ВычислитьБулево(Вспомогательный.ЗначениеСвойства(ВходящиеДанные, "removed"));
	
КонецПроцедуры

// Представление роли пользователя
//
// Возвращаемое значение:
// 	Строка
//
Функция ПредставлениеРоли() Экспорт
	Возврат РолиХранилища.ПредставлениеРоли(Роль);
КонецФункции
